from __future__ import generators
import plus
import Arenas
import random
import Hazards
import math

class BoxArena(Arenas.SuperArena):
    "Drive as far as you want...you'll never reach the end of this infinite arena.  You must use the Orbit camera (F2)."
    name = "Infinity Arena"
    preview = "infinity/infinity.bmp"
    game_types = ['DEATHMATCH', 'BATTLE ROYAL', 'TEAM MATCH']
    extent = (-30, 30, 30, -30)

    def __init__(self):
        Arenas.SuperArena.__init__(self, "Arenas/infinity/infinity.gmf")
        plus.setBackColor(0.5,0.5,0.5)
        degrad = 0.01745
        self.AddStaticCamera("Use Orbit Cam!", (0, 8, 10), (30*degrad,math.pi), 84*degrad)
	self.AddStaticCamera("It's F2!", (0, 15, 12), (45*degrad,math.pi), 84*degrad)
	self.AddStaticCamera("Use Orbit Cam!!", (0, 20, 14), (60*degrad,math.pi), 84*degrad)
	self.AddStaticCamera("It's F2!!", (0, 24, 16), (75*degrad,math.pi), 84*degrad)
	self.AddWatchCamera("Orbit Cam is F2!", (0, 8, 0), (6, 18, 30*degrad, 10*degrad))
	self.AddWatchCamera("Use it!", (0, 10, 0), (6, 20, 30*degrad, 20*degrad))
	self.AddWatchCamera("It's better!", (0, 12, 0), (6, 22, 30*degrad, 30*degrad))
	self.AddWatchCamera("You can't see your bot like this!", (0, 14, 0), (6, 24, 30*degrad, 40*degrad))
        self.players = ()

    def Activate(self, on):
        if on: self.players = plus.getPlayers()
        
        Arenas.SuperArena.Activate(self, on)
        
    def Tick(self):
        x = plus.getLocation(0)[0]
        y = plus.getLocation(0)[1]
        z = plus.getLocation(0)[2]
        c = ((x ** 2 + z ** 2) ** 0.5)/2000
        if c<1:
            plus.setBackColor(1-c,1-c,1-c)
        if c>=1:
            plus.setBackColor(0,0,0)
            
        return Arenas.SuperArena.Tick(self)
        
Arenas.register(BoxArena)
